//*************************************************************************************
//  : SQ7617_SIO.c
// 汾     : V1.0
//      : SIO ʹú
// ע     : SIO غ㼯ڱӳ
//**************************************************************************************
#include "main.h"
unsigned char tmpChar, s_rx;


//*********************************************************************
// 	: SIO0_init()
// 	: SIO0ʼ
// ע		: SIO0 IOܽSIOģʽ
//			  *趨SIO0ΪSlave mode , (External clock source) 
//*********************************************************************

void SIO0_Init()
{
/*	
//--- Master mode ( SIOCKS=(000~110) ʱѡ²趨)-------------------
//====== SIO0ܽųʼ ======


//--- SI0(P0.5) ; SO0(P0.4) ; SCK0(0.6)-------
	FSELR0 = (FSELR0&0x0F)|0x20;			  // 趨ѡĴ0
	PCSELR2_SIO0 = 0x00;					  // 趨ΧͨѡĴ
	
	P0FC1_P5 = 1;							  // P0.5趨ΪSI0
	P0FC2_P5 = 0;
	P0FC1_P4 = 1;							  // P0.4趨ΪSO0
	P0FC2_P4 = 0;	
	P0FC1_P6 = 1;                             // P0.6趨ΪSCK0
	P0FC2_P6 = 0;
*/


/*
//--- SI0(P2.5) ; SO0(P2.6) ; SCK0(2.4)-------
	FSELR2 = (FSELR2&0x0F)|0x20;			  // 趨ѡĴ2
	PCSELR2_SIO0 = 0x01;					  // 趨ΧͨѡĴ
	
	P2FC1_P5 = 1;						      // P2.5趨ΪSI0
	P2FC2_P5 = 0;
	P2FC1_P6 = 1;                             // P2.6趨ΪSO0
	P2FC2_P6 = 0;	
	P2FC1_P4 = 1;                             // P2.4趨ΪSCK0
	P2FC2_P4 = 0;
*/


/*
//====== SIO0ģʽ ======
	PCKEN2_SIO0 = 1;	            	  	  // SIO0ܿ( Enable)
	SIO0CR1_SIOEDG  = 0;                 	  // ؽ½ش
    SIO0CR1_SIOCKS  = 0x00;              	  // ѡ clock Ϊ fcgck/2^9
    SIO0CR1_SIODIR  = 1;                 	  // MSB ( bit7 ʼ)
    SIO0CR1_SIOM    = 0x03;              	  // ѡ SIO ģʽ8 λͼģʽ
*/





//--- Slave mode ( SIOCKS=111(ʹⲿ clock) ʱѡ²趨)----------
//====== SIO0ܽųʼ ======


//--- SI0(P0.5) ; SO0(P0.4) ; SCK0(0.6)------- [ѡܽ]
	FSELR0 = (FSELR0&0x0F)|0x20;			  // 趨ѡĴ0
	PCSELR2_SIO0 = 0x00;					  // 趨ΧͨѡĴ
	
	P0FC1_P5 = 1;							  // P0.5趨ΪSI0
	P0FC2_P5 = 0;
	P0FC1_P4 = 1;							  // P0.4趨ΪSO0
	P0FC2_P4 = 0;	
	P0FC1_P6 = 1;                             // P0.6趨ΪSCK0
	P0FC2_P6 = 0;



/*
//--- SI0(P2.5) ; SO0(P2.6) ; SCK0(2.4)-------
	FSELR2 = (FSELR2&0x0F)|0x20;			  // 趨ѡĴ2
	PCSELR2_SIO0 = 0x01;					  // 趨ΧͨѡĴ
	
	P2FC1_P5 = 1;                             // P2.5趨ΪSI0
	P2FC2_P5 = 0;
	P2FC1_P6 = 1;                             // P2.6趨ΪSO0
	P2FC2_P6 = 0;	
	P2FC1_P4 = 1;                             // P2.4趨ΪSCK0
	P2FC2_P4 = 0;
*/

//====== SIO0ģʽ ======
	PCKEN2_SIO0 = 1;	            	  	  // SIO0ܿ( Enable)
	
// 	SIO0CR1_SIOEDG  = 0;                 	  // ؽ½ش
//  SIO0CR1_SIOCKS  = 0x07;              	  // ⲿʱ
//  SIO0CR1_SIODIR  = 1;                 	  // MSB ( bit7 ʼ)
//  SIO0CR1_SIOM    = 0x03;              	  // ѡ SIO ģʽ8 λͼģʽ
	
	SIO0CR1 = 0x0B|(SIO_CKS_EXT<<4);	
}



//*********************************************************************
// 	: SIO1_init()
// 	: SIO1ʼ
// ע		: SIO1 IOܽSIOģʽ
//			  *趨SIO1Ϊ Master mode
//*********************************************************************
void SIO1_Init()
{

//--- Master mode ( SIOCKS=(000~110) ʱѡ²趨)-------------------
//====== SIO1ܽųʼ ======


//--- SI1(P0.0) ; SO1(P0.1) ; SCK1(0.2)-------[ѡܽ]
	FSELR0 = (FSELR0&0xF0)|0x02;			  // 趨ѡĴ0
	PCSELR2_SIO1 = 0x00;					  // 趨ΧͨѡĴ

	P0FC1_P0 = 1;							  // P0.0趨ΪSI1
	P0FC2_P0 = 0;
	P0FC1_P1 = 1;							  // P0.1趨ΪSO1
	P0FC2_P1 = 0;	
	P0FC1_P2 = 1;							  // P0.2趨ΪSCK1
	P0FC2_P2 = 0;



/*
//--- SI1(P2.1) ; SO1(P2.0) ; SCK1(2.2)-------
    FSELR2 = (FSELR2&0xF0)|0x02;			  // 趨ѡĴ2
	PCSELR2_SIO1 = 0x01;					  // 趨ΧͨѡĴ

	P2FC1_P1 = 1;                             // P2.1趨ΪSI1
	P2FC2_P1 = 0;
	P2FC1_P0 = 1;                             // P2.0趨ΪSO1
	P2FC2_P0 = 0;	
	P2FC1_P2 = 1;                             // P2.2趨ΪSCK1
	P2FC2_P2 = 0;
*/


//====== SIO1ģʽ ======
	PCKEN2_SIO1 = 1;	            	  	  // SIO1ܿ( Enable)
	
// 	SIO1CR1_SIOEDG  = 0;                 	  // ؽ½ش
//  SIO1CR1_SIOCKS  = 0x00;              	  // ѡ clock Ϊ fcgck/2^9
//  SIO1CR1_SIODIR  = 1;                 	  // MSB ( bit7 ʼ)
//  SIO1CR1_SIOM    = 0x03;              	  // ѡ SIO ģʽ8 λͼģʽ
	
	SIO1CR1 = 0x0B|(SIO_CKS_DIV512<<4);


/*
//--- Slave mode ( SIOCKS=111(ʹⲿ clock) ʱѡ²趨)----------
//====== SIO1ܽųʼ ======


//--- SI1(P0.0) ; SO1(P0.1) ; SCK1(0.2)-------
	FSELR0 = (FSELR0&0xF0)|0x02;			  // 趨ѡĴ0
	PCSELR2_SIO1 = 0x00;					  // 趨ΧͨѡĴ
	
	P0FC1_P0 = 1;							  // P0.0趨ΪSI1
	P0FC2_P0 = 0;
	P0FC1_P1 = 1;                             // P0.1趨ΪSO1
	P0FC2_P1 = 0;	
	P0FC1_P2 = 1;                             // P0.2趨ΪSCK1
	P0FC2_P2 = 0;
*/



/*
//--- SI1(P2.1) ; SO1(P2.0) ; SCK1(2.2)-------
    FSELR2 = (FSELR2&0xF0)|0x02;			  // 趨ѡĴ2	
	PCSELR2_SIO1 = 0x01;					  // 趨ΧͨѡĴ
	
	P2FC1_P1 = 1;                             // P2.1趨ΪSI1
	P2FC2_P1 = 0;
	P2FC1_P0 = 1;                             // P2.0趨ΪSO1
	P2FC2_P0 = 0;	
	P2FC1_P2 = 1;                             // P2.2趨ΪSCK1
	P2FC2_P2 = 0;
*/



//====== SIO1ģʽ ======
/*
	PCKEN2_SIO1 = 1;	            	  	  // SIO1ܿ( Enable)
	SIO1CR1_SIOEDG  = 0;                 	  // ؽ½ش
    SIO1CR1_SIOCKS  = 0x07;              	  // ⲿʱ
    SIO1CR1_SIODIR  = 1;                 	  // MSB ( bit7 ʼ)
    SIO1CR1_SIOM    = 0x03;              	  // ѡ SIO ģʽ8 λͼģʽ
	//SIO1CR1 = 0x0B|(SIO_CKS_DIV512<<4);

*/

	
}



//*********************************************************************
// 	: SIO_Start()
// 	: SIO
// ע		:
//*********************************************************************
void SIO_Start(unsigned char sio)
{
	P4DO_P3 = 0;							  // ģ/SS PIN,趨P4.3ܽL
	if(sio == SIO_0){
		SIO0CR1_SIOS  = 1;               	  // SIO0͹ʼ
		SIO0CR2_SPIEN = 1;              	  // SIO0S
	}
	else if(sio == SIO_1){
		SIO1CR1_SIOS  = 1;               	  // SIO1͹ʼ
		SIO1CR2_SPIEN = 1;              	  // SIO1S
	}

}


//*********************************************************************
// 	: SIO0_Stop()
// 	: ֹͣSIO
// ע		:
//*********************************************************************
void SIO_Stop(unsigned char sio)
{
	if(sio == SIO_0){
		SIO0CR1_SIOS  = 0;               	  // SIO0͹ֹͣ
		SIO0CR2_SPIEN = 0;					  // SIO0ֹ
	}
	else if(sio == SIO_1){
		SIO1CR1_SIOS  = 0;               	  // SIO1͹ֹͣ
		SIO1CR2_SPIEN = 0;					  // SIO1ֹ
	}
	P4DO_P3 = 1;							  // ģ/SS PIN,趨P4.3ܽH
}


//*********************************************************************
// 	: SIO_IntEnable()
// 	: SSIOж
// ע		:
//*********************************************************************
void SIO_IntEnable(unsigned char sio)
{
	__ASM("DI");							  // ֹпж
	
	if(sio == SIO_0){
	    IER_SIO0 = 1;						  // 趨SIO0ж
	}
	else if(sio == SIO_1){
		IER_SIO1 = 1;                         // 趨SIO1ж
	}
	
	__ASM("EI");							  // пж
}



//*********************************************************************
// 	: SIO_ByteSend()
// 	: SIO
// ע		: SIO0, SIO1 
//*********************************************************************
void SIO_ByteSend(unsigned char sio, unsigned char txdata){
	if(sio == SIO_0){  
		while(SIO0SR_TBFL == 1);      			// TBFL鷢꣬ͶʱȴͻΪʱдһ
		SIO0BUF = txdata;           			// YρGl͕ SIO
		__ASM("NOP");							// ָ
		//  CLR_WDT;                			// Źʱ (ι)
        
		SIO0CR1_SIOS = 1;       				// SIOS SIO
		while(SIO0SR_SEF == 1);           		// SEFȷһǷ    
		tmpChar = SIO0BUF;						// xһΕ  SҲY	
	}
	else if(sio == SIO_1){
		while(SIO1SR_TBFL == 1);      			// TBFL鷢꣬ͶʱȴͻΪʱдһ
		SIO1BUF = txdata;           			// YρGl͕ SIO
		__ASM("NOP");							// ָ
		//  CLR_WDT;                			// Źʱ (ι)
        
		SIO1CR1_SIOS = 1;       				// SIOS SIO
		while(SIO1SR_SEF == 1);           		// SEFȷһǷ    
		tmpChar = SIO1BUF;						// xһΕ  SҲY	
	}
}


//*********************************************************************
// 	: SIO_ByteRead()
// 	: SIO(ȡ)
// ע		:
//*********************************************************************
unsigned char SIO_ByteRead(unsigned char sio){
unsigned char r_data;

	if(sio == SIO_0){
		while(SIO0SR_TBFL == 1);	//zl͝MǷ_ _ ȴ lP]
		SIO0BUF = 0xff;				//ѕFF aCLK ׌SY
		tmpChar = SIO0BUF;			//xһΕ  SҲY
		while(SIO0SR_RENDB == 0);	//鿴Ƿ_
		r_data = SIO0BUF;		    //Yx
	}
	else if(sio == SIO_1){
		while(SIO1SR_TBFL == 1);	//zl͝MǷ_ _ ȴ lP]
		SIO1BUF = 0xff;				//ѕFF aCLK ׌SY
		tmpChar = SIO1BUF;			//xһΕ  SҲY
		while(SIO1SR_RENDB == 0);	//鿴Ƿ_
		r_data = SIO1BUF;		    //Yx
	}
	return r_data;
}


//*********************************************************************
// 	: SIO_ReservedStopWait
// 	: ȴ SIO ֹͣ
// ע		:  SIOS=0(ֹͣ SIO)(reserved stop) ж SIOF  (ȴ SIO ֹͣ)
//*********************************************************************
void SIO_ReservedStopWait(unsigned char sio){

if(sio == SIO_0){
    SIO0CR1_SIOS = 0;                   // SIOS=0: reserved stop

    while( SIO0SR_SIOF == 1 ){          // SIOF: ȴ SIO ֹͣ(SIOF=0)    
    //  __ASM("NOP");                   // ָ
    }
}
else  if(sio == SIO_1){
    SIO1CR1_SIOS = 0;                   // SIOS=0: reserved stop

    while( SIO1SR_SIOF == 1 ){          // SIOF: ȴ SIO ֹͣ(SIOF=0)    
    //  __ASM("NOP");                   // ָ
    }
}


}


//*********************************************************************
// 	: __interrupt IntSIO0(void)
// 	: SIO0 жӳ
// ע		: *SIO0ΪSlave,SIO1ΪSlave,дSIO1 жӳ
//*********************************************************************
void __interrupt IntSIO0(void){
	
    __ASM("NOP");						// ָ


	if(SIO0SR_RENDB)					//_JǷYҪx
	{
	   s_rx = SIO0BUF;                  //SlaveYx
		if(s_rx == 0x55)                
		{
			if(SIO0SR_TBFL==0)
			{
				SIO0BUF = 0x76;         //SlaveݔY
			}				
		}
		else if(s_rx == 0xAA)
		{
			if(SIO0SR_TBFL==0)
			{
				SIO0BUF = 0x17;         //SlaveݔY
			}
		}
		else if(s_rx == 0xF0)
		{
			if(SIO0SR_TBFL==0)
			{
				SIO0BUF = 0x98;         //SlaveݔY
			}
		}
// 		else
// 		{
// 			if(SIO0SR_TBFL==0)
// 			{
// 				SIO0BUF = 0xFF;         //SlaveݔdummyY
// 			}
// 		}
	}
}


//*********************************************************************
// 	: __interrupt IntSIO1(void)
// 	: SIO1 жӳ
// ע		:
//*********************************************************************
void __interrupt IntSIO1(void)
{
	__ASM("NOP");							  // ָ

	

}


