//SQ7617_SIO
//*************************************************************************************
// 	: main.c
// 汾		: V1.0
// 		: 
// ˵	: ΪһSQ7617SIO1ΪMaster,SIO0ΪSlave
//			  °1: SIO1ͳ0x55 ȷ(0x76)LED1δͨѶմLED1
//      	  °2: SIO1ͳ0xAA ȷ(0x17)LED2δͨѶմLED1
//      	  °3: SIO1ͳ0xF0 ȷ(0x98)LED3δͨѶմLED1
// 
// ע		: 1. SIO1(ΪMaster) 
//			         (P0.2)ΪSCLK1
//		             (P0.0)ΪSI1
//					 (P0.1)ΪSO1
// 
//			  2. SIO0(ΪSlave) 
//			         (P0.6)ΪSCLK0
//		             (P0.5)ΪSI0
//					 (P0.4)ΪSO0
// 
//			  3. (P0.2)SCLK1----ӵ----(P0.6)SCLK0;
//				 (P0.0)SI1  ----ӵ----(P0.4)SO0 ;    MISO
//				 (P0.1)SO1  ----ӵ----(P0.5)SI0 ;    MOSI
// 				 (P4.3)/SS ģ⾧ƬPINslave ֻ /SS źΪ͵λʱ, Ŷ master ĲָзӦ[ҪʹLA SPI¼ƴ֮ʱ]
// 
//			  4. []	1  BTN1_in(P3.0)  [IntEXT0]
//						    2  BTN2_in(P3.1)  [IntEXT1]
//						    3  BTN3_in(P3.7)  [IntEXT7]
// 
//				  [LED] LED 1  (P2.0)
//				  [LED] LED 2  (P2.1)
//				  [LED] LED 3  (P2.2)
//**************************************************************************************
#ifndef	IO_MEM
#define	IO_MEM
#endif
#include "main.h"

/* ----------------------  -------------------------- */

unsigned char m_rx;

/* -----------------------  --------------------------- */
void main()
{
/* ---------------------- ϵͳʼ ------------------------ */
	PLLCR0_PLLEN  = 1;                     	  //  PLL
	while(PLLCR0_PLLRDY ==0);				  // ȴ PLL 
	CLKCR0_SCKPSC = 1;                        // ϵͳƵʳ2   (48M/2=24MHz) 
    CLKCR0_SCKSRC = 1;                        // ʱԴлPLL
	while(CLKCR0_SCKRDY ==0);				  // ȴ ϵͳʱ 
/* ---------------------- ܽųʼ ------------------------ */
    P2OE  = 0x07;                        	  // 趨P2.0,P2.1,P2.2 ܽΪ
    P3OE  = 0x7C;                        	  // 趨P3.0,P3.1,P3.7 ܽΪ
	P3PU |= 0x83;                       	  // 趨P3.0,P3.1,P3.7 
	P4OE_P3 = 1;							  // 趨P4.3ܽΪ
	P4DO_P3 = 1;							  // ʼ趨P4.3ܽߵƽ
	LED1_out = 1;							  // ʼ趨LED1Ϊ״̬
	LED2_out = 1;							  // ʼ趨LED2Ϊ״̬
	LED3_out = 1;							  // ʼ趨LED3Ϊ״̬
/* ---------------------- EINT ʼ ------------------------ */
	EINT_Init();                        	  // EINT ʼ趨
	EINT_IntEnable();                   	  // ⲿжEINT
/* ---------------------- SIO1 ʼ ------------------------ */
    SIO1_Init();                        	  // SIO1ʼOMaster
/* ---------------------- SIO0 ʼ ------------------------ */
	SIO0_Init();                        	  // SIO0OSlave  
	SIO_IntEnable(SIO_0);               	  // SIO0Д
/* ---------------------- SIO  --------------------------- */	
	SIO_Start(SIO_0);                   	  // SIO_ʼY
//---------------------------------------------------------------------
    while(1){
		if(Push_BTN1_Flag){      	  		  // 1_ ֮ⲿжBTN1(IntEXT0)=1
			SIO_Start(SIO_0);                 // SIO_ʼY
			Push_BTN1_Flag = 0;				  // "1_ ֮ⲿж"BTN1(IntEXT0)һΰ
			SIO_ByteSend(SIO_1,0x55);	  	  // SIO10x55
			m_rx = SIO_ByteRead(SIO_1);	      // SIO1

			if(m_rx == 0x76)          		  // Arx dataΪ0x76
			{
				LED1_out = 0;           	  // LED1
			}
			else
			{
				LED1_out = 1;           	  // LED1
			}
		SIO_Stop(SIO_0);                   	  // ֹͣSIO	
		}
		//---------------------------------------------------------------
		if(Push_BTN2_Flag){      	  		  // 2_ ֮ⲿжBTN2(IntEXT1)=1
			SIO_Start(SIO_0);                 // SIO_ʼY
			Push_BTN2_Flag = 0;				  // "2_ ֮ⲿж"BTN2(IntEXT1)һΰ
			SIO_ByteSend(SIO_1, 0xAA);		  // SIO10xAA
			m_rx = SIO_ByteRead(SIO_1);		  // SIO1
			
			if(m_rx == 0x17)          		  // Arx dataΪ0x17
			{
				LED2_out = 0;           	  // LED2
			}
			else
			{
				LED2_out = 1;                 // LED2
			}
		SIO_Stop(SIO_0);                   	  // ֹͣSIO	
		}
		//---------------------------------------------------------------
		if(Push_BTN3_Flag){      	  		  // 3_ ֮ⲿжBTN3(IntEXT7)=1
			SIO_Start(SIO_0);                 // SIO_ʼY
			Push_BTN3_Flag = 0;				  // "3_ ֮ⲿж"BTN3(IntEXT7)һΰ
			SIO_ByteSend(SIO_1,0xF0);		  // SIO10xF0
			m_rx = SIO_ByteRead(SIO_1);		  // SIO1
			
			if(m_rx == 0x98)          		  // Arx dataΪ0x98
			{
				LED3_out = 0;           	  // LED3
			}
			else
			{				
				LED3_out = 1;           	  // LED3
			}
		SIO_Stop(SIO_0);                   	  // ֹͣSIO	
		}
	
    }
}


/* ---------------------- жϷ ------------------------ */
void __interrupt OnlyReti(void)
{
	__asm("NOP"); 							  // ָ
}

void __interrupt_n OnlyRetn(void)
{
	__asm("NOP");							  // ָ
}

void __interrupt_n IntWDT(void)
{
	__asm("NOP");							  // ָ
}

void __interrupt_n IntSWI(void)			  // SWIλжϷ
{
	PRSTR7 = 0x5a;
	PRSTR7 = 0xa5;
	PRSTR7 = 0xc3;
	PRSTR7 = 0x3c;	
}
/* -------------------  жϷ ---------------------- */

/* -------------------- SQ7617ж ------------------ */
#pragma section const INT_VECTOR1 0xff40
void * const IntTbl1[] = {											
	OnlyReti,				/* 0xff40 : Reserved		*/									
	OnlyReti,				/* 0xff42 : Reserved		*/									
	OnlyReti,				/* 0xff44 : Reserved		*/									
	OnlyReti,				/* 0xff46 : Reserved		*/								
	OnlyReti,				/* 0xff48 : Reserved		*/									
	OnlyReti,				/* 0xff4a : Reserved		*/									
	OnlyReti,				/* 0xff4c : Reserved		*/									
	OnlyReti,				/* 0xff4e : Reserved		*/									
	OnlyReti,				/* 0xff50 : Reserved		*/									
	OnlyReti,				/* 0xff52 : Reserved		*/									
	OnlyReti,				/* 0xff54 : Reserved		*/									
	OnlyReti,				/* 0xff56 : Reserved		*/									
	OnlyReti,				/* 0xff58 : IntTCA7			*/	//жԴ:TCA7 16λʱ								
	OnlyReti,				/* 0xff5a : IntTCA6			*/	//жԴ:TCA6 16λʱ							
	OnlyReti,				/* 0xff5c : Reserved		*/									
	OnlyReti,				/* 0xff5e : Reserved		*/									
	OnlyReti,				/* 0xff60 : Reserved		*/									
	OnlyReti,				/* 0xff62 : Reserved		*/									
	OnlyReti,				/* 0xff64 : Reserved		*/									
	OnlyReti,				/* 0xff66 : Reserved		*/									
	OnlyReti,				/* 0xff68 : Reserved		*/									
	OnlyReti,				/* 0xff6a : Reserved		*/									
	OnlyReti,				/* 0xff6c : IntTX2			*/	//жԴ:UART2 TX2								
	OnlyReti,				/* 0xff6e : IntRX2			*/	//жԴ:UART2 RX2							
	OnlyReti,				/* 0xff70 : Reserved		*/									
	OnlyReti,				/* 0xff72 : Reserved		*/									
	OnlyReti,				/* 0xff74 : Reserved		*/									
	OnlyReti,				/* 0xff76 : IntTCA5			*/	//жԴ:TCA5 16λʱ								
	OnlyReti,				/* 0xff78 : IntTCA4			*/	//жԴ:TCA4 16λʱ								
	OnlyReti,				/* 0xff7a : Reserved		*/									
	OnlyReti,				/* 0xff7c : Reserved		*/									
	OnlyReti,				/* 0xff7e : Reserved		*/									
	OnlyReti,				/* 0xff80 : Reserved		*/									
	OnlyReti,		    	/* 0xff82 : Reserved		*/									
	OnlyReti,	    		/* 0xff84 : Reserved		*/									
	OnlyReti,				/* 0xff86 : Reserved		*/									
	OnlyReti,				/* 0xff88 : Reserved		*/									
	OnlyReti,				/* 0xff8a : Reserved		*/									
	IntSIO1,				/* 0xff8c : IntSIO1			*/	//жԴ:SIO 1								
	OnlyReti,				/* 0xff8e : IntI2C1			*/	//жԴ:I2C 1						
	OnlyReti,				/* 0xff90 : IntTX1			*/	//жԴ:UART1 TX1							
	OnlyReti,				/* 0xff92 : IntRX1			*/	//жԴ:UART1 RX1								
	OnlyReti,				/* 0xff94 : Reserved		*/									
	OnlyReti,				/* 0xff96 : Reserved		*/									
	OnlyReti,				/* 0xff98 : Reserved		*/									
	OnlyReti,				/* 0xff9a : IntTCA3			*/	//жԴ:TCA3 16λʱ							
	OnlyReti,				/* 0xff9c : IntTCA2			*/	//жԴ:TCA2 16λʱ								
	OnlyReti,				/* 0xff9e : Reserved		*/									
	OnlyReti,				/* 0xffa0 : IntMAC			*/	//жԴ:˷								
	IntEXT7,				/* 0xffa2 : IntEXT7			*/	//ⲿж7								
	OnlyReti,				/* 0xffa4 : IntEXT6			*/	//ⲿж6								
	OnlyReti,				/* 0xffa6 : IntEXT5			*/	//ⲿж5								
	OnlyReti,				/* 0xffa8 : IntEXT4			*/	//ⲿж4								
	OnlyReti,				/* 0xffaa : Reserved		*/									
	OnlyReti,				/* 0xffac : Reserved		*/									
	OnlyReti,				/* 0xffae : Reserved		*/							
	OnlyReti,				/* 0xffb0 : IntDIC			*/	//жԴ:DIC								
	OnlyReti,				/* 0xffb2 : Reserved		*/							
	OnlyReti,				/* 0xffb4 : Reserved		*/									
	OnlyReti,				/* 0xffb6 : Reserved		*/									
	OnlyReti,				/* 0xffb8 : Reserved		*/									
	OnlyReti,				/* 0xffba : Reserved		*/									
	OnlyReti,				/* 0xffbc : Reserved		*/									
	OnlyReti,				/* 0xffbe : Reserved		*/									
	OnlyReti,				/* 0xffc0 : Reserved		*/									
	OnlyReti,				/* 0xffc2 : Reserved		*/									
	OnlyReti,				/* 0xffc4 : IntFMC			*/	//жԴ:Flash								
	OnlyReti,				/* 0xffc6 : Reserved		*/					
	OnlyReti,				/* 0xffc8 : Reserved		*/									
	OnlyReti,				/* 0xffca : Reserved		*/									
	OnlyReti,				/* 0xffcc : Reserved		*/									
	OnlyReti,               /* 0xffce : IntADC			*/	//жԴ:ADC								
	OnlyReti,				/* 0xffd0 : IntEXT3			*/	//ⲿж3								
	OnlyReti,				/* 0xffd2 : IntEXT2			*/	//ⲿж2								
	IntEXT1,				/* 0xffd4 : IntEXT1			*/	//ⲿж1								
	IntEXT0,				/* 0xffd6 : IntEXT0			*/	//ⲿж0								
	IntSIO0,				/* 0xffd8 : IntSIO0			*/	//жԴ:SIO 0								
	OnlyReti,				/* 0xffda : IntI2C0			*/	//***I2C0ڲEEPROMʹ***								
	OnlyReti,				/* 0xffdc : IntTX0			*/	//жԴ:UART0 TX0								
	OnlyReti,				/* 0xffde : IntRX0			*/	//жԴ:UART0 RX0								
	OnlyReti,				/* 0xffe0 : Reserved		*/									
	OnlyReti,				/* 0xffe2 : Reserved		*/									
	OnlyReti,				/* 0xffe4 : Reserved		*/									
	OnlyReti,				/* 0xffe6 : IntTCA1			*/	//жԴ:TCA1 16λʱ								
	OnlyReti,				/* 0xffe8 : IntTCA0			*/	//жԴ:TCA0 16λʱ								
	OnlyReti,				/* 0xffea : Reserved		*/									
	OnlyReti,				/* 0xffec : Reserved		*/									
	OnlyReti,			    /* 0xffee : IntRTC			*/	//жԴ:ʵʱʱRTCʱ								
	OnlyReti,				/* 0xfff0 : IntTBT			*/  //жԴ:ʱTBTʱ				
	OnlyReti,				/* 0xfff2 : Reserved		*/									
	OnlyReti,				/* 0xfff4 : IntCFD			*/	//жԴ:ʱʧЧ								
	OnlyReti,				/* 0xfff6 : IntLVD			*/	//жԴ:͵ѹLVD							
	IntWDT,					/* 0xfff8 : IntWDT			*/	//non-maskable жԴ:Źʱ		
	(void *)0xffff,			/* 0xfffa : Reserved		*/									
	IntSWI,					/* 0xfffc : IntSWI/INTUNDEF */	//non-maskable		
	STARTUP					/* 0xfffe : RESET			*/	//non-maskable			
};
#pragma section const
/* -------------------  SQ7617ж ---------------------- */

